package net.shrine.adapter

import net.shrine.adapter.i2b2Protocol.QueryMaster
import net.shrine.adapter.i2b2Protocol.query.{I2b2QueryDefinition, Term}
import net.shrine.protocol.i2b2.AuthenticationInfo
import net.shrine.protocol.i2b2.Credential
import net.shrine.xml.XmlDateHelper

import scala.concurrent.duration.FiniteDuration

/**
 * @author clint
 * @since Nov 28, 2012
 */
trait AdapterTestHelpers {
  val queryId = 123
  val localMasterId = "kasjdlsajdklajsdkljasd"
  val bogusQueryId = 999
  
  val masterId1 = "1"
  val masterId2 = "2"
  val masterId3 = "3"
  val masterId4 = "4"

  val networkQueryId1 = 1L
  val networkQueryId2 = 2L
  val networkQueryId3 = 3L
  val networkQueryId4 = 4L

  val queryName1 = "query-name1"
  val queryName2 = "query-name2"
  val queryName3 = "3query-name2"

  lazy val queryDef1: I2b2QueryDefinition = I2b2QueryDefinition(queryName1, Term("x", "xName"))
  lazy val queryDef2: I2b2QueryDefinition = I2b2QueryDefinition(queryName2, Term("y", "yName"))
  lazy val queryDef3: I2b2QueryDefinition = I2b2QueryDefinition(queryName3, Term("y", "yName"))

  val userId = "some-other-user"

  val domain = "Some-other-domain"
  val anotherDomain = "some-completely-different-domain"

  val password = "some-val"

  lazy val authn: AuthenticationInfo = AuthenticationInfo(domain, userId, Credential(password, isToken = false))
  lazy val authn2: AuthenticationInfo = AuthenticationInfo(authn.domain, "a-different-user", Credential("jkafhkjdhsfjksdhfkjsdg", isToken = false))
  
  val projectId = "some-project-id"

  import scala.concurrent.duration.DurationInt
    
  val waitTime: FiniteDuration = 12345.milliseconds

  lazy val queryMaster1: QueryMaster = i2b2Protocol.QueryMaster(masterId1, networkQueryId1, queryName1, userId, domain, XmlDateHelper.now, flagged = Some(true))
  lazy val queryMaster2: QueryMaster = i2b2Protocol.QueryMaster(masterId2, networkQueryId2, queryName2, userId, domain, XmlDateHelper.now, flagged = Some(false))
  lazy val queryMaster4: QueryMaster = i2b2Protocol.QueryMaster(masterId4, networkQueryId4, queryName2, authn2.username, anotherDomain, XmlDateHelper.now, flagged = Some(true))
}

object AdapterTestHelpers extends AdapterTestHelpers