package net.shrine

import cats.effect.{ContextShift, IO}
import javax.servlet.annotation.WebListener
import javax.servlet.{ServletContextEvent, ServletContextListener}
import net.shrine.http4s.catsio.ExecutionContexts
import net.shrine.http4s.servlet.ShrineServletContextSyntax


/**
  * This class is needed to load the http4s services in a servlet container
  * Created by marc-danie on 7/24/18.
  */

@WebListener
class Bootstrap extends ServletContextListener {

  implicit val cs: ContextShift[IO] = IO.contextShift(ExecutionContexts.dispatchExecutionContext)

  override def contextInitialized(sce: ServletContextEvent): Unit = {
    ShrineServletContextSyntax.mountService(sce.getServletContext, "SHRINE Mock Service", MockCRCApp.service)
  }
}
