package net.shrine.protocol.version

import net.shrine.protocol.version.v2.V2JsonTest
import net.shrine.util.ShouldMatchersForJUnit
import org.junit.Test

class V2EnvelopeTest extends ShouldMatchersForJUnit {

  val jsonEnvelope = V2JsonTest.readJsonFile("/v2/envelope.json")
  val expectedEnvelope = Envelope(
    contents = "test contents",
    contentsType = "test contents type",
    contentsSubject = 0,
    protocolVersion = v2.versionId
  )

  @Test
  def testEnvelopeAgainstV2Json():Unit = {
    assertResult(jsonEnvelope){ expectedEnvelope.asJsonText.underlying }
    assertResult(expectedEnvelope){ Envelope.tryRead(new JsonText(jsonEnvelope)).get }
  }
}
