package net.shrine.protocol.version.v2

import net.shrine.protocol.version.QueryId
import org.junit.Test

class UpdateQueryAtAdapterTest {

  val jsonUpdateQueryAtAdapterWithName: String = V2JsonTest.readJsonFile("/v2/updateQueryAtAdapterWithName.json")
  val jsonUpdateQueryAtAdapterWithFlagging: String = V2JsonTest.readJsonFile("/v2/updateQueryAtAdapterWithFlagging.json")

  val expectedUpdateQueryAtAdapterWithName: UpdateQueryAtAdapterWithName = UpdateQueryAtAdapterWithName (
    queryId = new QueryId(V2JsonTest.staticQueryId),
    expectedItemVersion = None,
    queryName = "test query name"
  )
  val expectedUpdateQueryAtAdapterWithFlagging: UpdateQueryAtAdapterWithFlagging = UpdateQueryAtAdapterWithFlagging (
    queryId = new QueryId(V2JsonTest.staticQueryId),
    expectedItemVersion = None,
    flagged = true,
    flaggedMessage = Some("test flagged message")
  )

  @Test
  def testUpdateQueryAtAdapterAgainstV2Json():Unit = {
    V2JsonTest.testRoundTrip(jsonUpdateQueryAtAdapterWithName, expectedUpdateQueryAtAdapterWithName, UpdateQueryAtAdapter.tryRead)
    V2JsonTest.testRoundTrip(jsonUpdateQueryAtAdapterWithFlagging, expectedUpdateQueryAtAdapterWithFlagging, UpdateQueryAtAdapter.tryRead)
  }
}
