package net.shrine.http4s.catsio

import cats.Eval
import cats.effect.{IO, SyncIO}
import net.shrine.log.Loggable

/**
 * IO-based lazy cache of a value
 */
object LazyIO extends Loggable {
  def apply[A](logString:String)(blockIO:IO[A]):IO[A] = {
    SyncIO.eval(Eval.later { //Eval.later memoizes the results - so that it's only calculated on first use
      val logIO = IO(info(logString))
      logIO.flatMap(_ => blockIO).unsafeRunSync() //SyncIO makes it safe to call unsafeRunSync()
    })
  }.toIO
}
