package net.shrine.http4s.client.legacy

import java.net.URL
import java.util.concurrent.TimeUnit

import com.typesafe.config.Config
import net.shrine.config.ConfigSource

import scala.concurrent.duration.FiniteDuration

/**
 * @author clint
 * @since Dec 5, 2013
 */
import net.shrine.config.ConfigExtensions

final case class EndpointConfig(url: URL, timeout: FiniteDuration, clientConfig:Config)

object EndpointConfig {
  object Keys {
    val urlPath = "urlPath"
    val timeout = "timeout"
  }

  val defaultTimeout: FiniteDuration = FiniteDuration.apply(4,TimeUnit.DAYS)

  def apply(config: Config): EndpointConfig = {

    val url:URL = config.buildURI("i2b2BaseUrl", Keys.urlPath, new URL(_), Some(ConfigSource.config.getConfig("shrine")))
    val timeout = {
      import net.shrine.config.ConfigExtensions
      config.getFiniteDuration(Keys.timeout)
      if(config.hasPath(Keys.timeout)) config.getFiniteDuration(Keys.timeout)
      else defaultTimeout
    }
    
    EndpointConfig(url, timeout, config)
  }
}