package net.shrine.hub.data.client

import cats.effect.IO
import net.shrine.protocol.version.{NodeId, NodeKey}
import org.http4s.{Method, Request, Uri}

object HubServiceRequests {

  def pingRequest(hubServiceUri: Uri): Request[IO] = Request(
    method = Method.GET,
    uri = hubServiceUri.withPath(s"${hubServiceUri.path}/ping")
  )

  def getNetworkRequest(hubServiceUri: Uri): Request[IO] = Request(
    method = Method.GET,
    uri = hubServiceUri.withPath(s"${hubServiceUri.path}/network")
  )

  def getNodeRequest(hubServiceUri: Uri,nodeKey:NodeKey): Request[IO] = Request(
    method = Method.GET,
    uri = hubServiceUri.withPath(s"${hubServiceUri.path}/node/${nodeKey.underlying}")
  )

  def getNodeRequest(hubServiceUri: Uri,nodeId:NodeId): Request[IO] = Request(
    method = Method.GET,
    uri = hubServiceUri.withPath(s"${hubServiceUri.path}/node/${nodeId.underlying}")
  )
}
