import PropTypes from "prop-types";

import { Error } from "./Error";

export const NetworkConfig = ({
  isFetching = false,
  error = Error(),
  domain = null,
  name = null,
  bannerText = null,
  shrineUrl = null,
  siteAdminEmail = null,
  termsOfUseText = null,
  unauthorizedMessage = null,
  usernameLabel = null,
  passwordLabel = null,
  defaultNumberOfOntologyChildren = null,
  queryFlaggingInstructions = null,
  flaggingIconInstructions = null,
  flaggingPlaceholderText = null,
  nextStepsUrl = null,
  helpLinks = {},
  ssoLogoutUrl= null,
  authType = null,
  sessionTimeoutMs = null,
} = {}) => {
  const response = {
    isFetching,
    error,
    domain,
    name,
    bannerText,
    shrineUrl,
    siteAdminEmail,
    termsOfUseText,
    unauthorizedMessage,
    usernameLabel,
    passwordLabel,
    defaultNumberOfOntologyChildren,
    queryFlaggingInstructions,
    flaggingIconInstructions,
    flaggingPlaceholderText,
    nextStepsUrl,
    helpLinks,
    ssoLogoutUrl,
    authType,
    sessionTimeoutMs,
  };

  return response;
};

NetworkConfig.propTypes = {
  domain: PropTypes.string,
  name: PropTypes.string,
  bannerText: PropTypes.string,
  shrineUrl: PropTypes.string,
  siteAdminEmail: PropTypes.string,
  termsOfUseText: PropTypes.string,
  unauthorizedMessage: PropTypes.string,
  usernameLabel: PropTypes.string,
  passwordLabel: PropTypes.string,
  defaultNumberOfOntologyChildren: PropTypes.number,
  queryFlaggingInstructions: PropTypes.string,
  flaggingIconInstructions: PropTypes.string,
  flaggingPlaceholderText: PropTypes.string,
  nextStepsUrl: PropTypes.string,
  helpLinks: PropTypes.shape({}),
  ssoLogoutUrl: PropTypes.string,
  authType: PropTypes.string,
  sessionTimeoutMs: PropTypes.string,
};
